/*
 * This Kotlin source file was generated by the Gradle 'init' task.
 */
package cz.fallingfox.aoc

import java.io.File

typealias Direction = Char

fun main() {
    val directions: List<Direction>
    val map: Map<String, Pair<String, String>>

    loadInput().let { input ->
        directions = parseDirections(input).also(::println)
        map = parseMap(input).also(::println)
    }

    val crossroads = map.keys.filter { it.last() == 'A' }
    crossroads.map {
        var crossroad = it
        var steps = 0L
        var index = 0
        while (true) {
            steps++
            val direction = directions[index++]
            val paths = map.getValue(crossroad)
            val newCrossroad = when (direction) {
                'L' -> paths.first
                'R' -> paths.second
                else -> {
                    throw Exception()
                }
            }

            if (newCrossroad.last() == 'Z') break

            crossroad = newCrossroad
            index %= directions.size
        }

        steps
    }.let { numbers ->
        var result = numbers[0]
        for (i in 1 until numbers.size) {
            result = lcm(result, numbers[i])
        }
        result
    }.let { println(it) }
}

fun lcm(a: Long, b: Long): Long {
    var larger = if (a > b) a else b
    val maxLcm = a * b
    var lcm = larger
    while (lcm <= maxLcm) {
        if (lcm % a == 0L && lcm % b == 0L) {
            return lcm
        }
        lcm += larger
    }
    return maxLcm
}

fun parseDirections(input: String) = input.lines().first().toCharArray().toList()
fun parseMap(input: String) = input.lines().drop(2).associate { line ->
    val crossroad = line.substring(0, 3)
    val paths = line.substring(line.indexOf('(') + 1, line.indexOf(')')).split(", ").let {
        Pair(it.first(), it.last())
    }

    crossroad to paths
}
fun loadInput(filename: String) = File(filename).readText()
fun loadTestInput() = loadInput("inputTest3.txt")
fun loadInput() = loadInput("input.txt")
